local Recount2 = Recount2

local math_fmod = math.fmod
local math_min = math.min

local BUFFER_SIZE = 64
local EVENTS_PER_FRAME = 5

local buffer = {}
local buffer_pos = 1
local buffer_length = 0

function Recount2:InitBuffer()
	for i = 1, BUFFER_SIZE do
		buffer[i] = {nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil}
	end

	self.dataInBuffer = false
end

function Recount2:AddToBuffer(srcGUID, dstGUID, spellID, ability, info, power, school, hitType, amount, resist, absorb, block, over)
	local newPos = buffer_pos+buffer_length
	
	if newPos>BUFFER_SIZE then
		newPos = 1
	end

	local curBuffer = buffer[newPos]

	--If the buffer size is the same as the current length have to process the event first
	if buffer_length==BUFFER_SIZE then
		self:AddMainData(unpack(buffer[buffer_pos]))
		buffer_pos = buffer_pos + 1
	else
		buffer_length = buffer_length + 1
	end

	curBuffer[1] = srcGUID
	curBuffer[2] = dstGUID
	curBuffer[3] = spellID
	curBuffer[4] = ability
	curBuffer[5] = info
	curBuffer[6] = power
	curBuffer[7] = school
	curBuffer[8] = hitType
	curBuffer[9] = amount
	curBuffer[10] = resist
	curBuffer[11] = absorb
	curBuffer[12] = block
	curBuffer[13] = over

	
	if self.dataInBuffer == false then
		self.EventFrame:SetScript("OnUpdate", self.HandleTimers)
		self.dataInBuffer = true
	end
end

function Recount2:ProcessBuffer()
	local processNum = math_min(EVENTS_PER_FRAME, buffer_length)
	for i = 1, processNum do
		self:AddMainData(unpack(buffer[buffer_pos]))

		buffer_pos = buffer_pos + 1
		if buffer_pos>BUFFER_SIZE then
			buffer_pos = 1
		end
	end
	--Decrement buffer length
	buffer_length = buffer_length - processNum

	if buffer_length==0 then
		self.dataInBuffer = false
	end
end
